import sys

models = []
fields = []

if len(sys.argv) <= 2:
    print "Run me: generate_admin.py <App Name> <Admin file>"
    exit()

adminfile = file(sys.argv[2], 'a')
adminfile.write(
    "# -*-coding:utf-8 -*-\nfrom django.contrib import admin\n\nfrom " + sys.argv[1] + ".models import *\n\n")

switcher = False

with open('models.py') as readmodel:
    for line in readmodel:
        parseline = line.split(" ")
        #If found class - forget about fields
        if parseline[0] == 'class':
            switcher = True
            classname = parseline[1].split("(")
            adminfile.write(parseline[0] + " admin" + classname[0] + "(admin.ModelAdmin):\n")
            models.append(classname[0])

        if switcher:
            fieldname = line.strip().split("=")[0].strip()
            fields.append(fieldname)

        if len(line) <= 1 and switcher == True:
            switcher = False
            fields.remove(fields[0])
            fields.remove('')

            fieldsformed = ''.join('"%s",' % fields).replace('",', '').replace('"', '')

            adminfile.write("\tlist_filter = " + fieldsformed + "\n")
            adminfile.write("\tsearch_fields = " + fieldsformed + "\n")
            adminfile.write("\tlist_display = " + fieldsformed + "\n")
            fields = []

adminfile.write("\n\n")
for classs in models:
    adminfile.write("admin.site.register(" + classs + ", admin" + classs + ")\n")

adminfile.close()

